# -*- coding: utf-8 -*-

from openerp import models, fields, api

class AccountInvoice(models.Model):
	_inherit = 'account.invoice'

	############################################################
	#	ACCOUNT INVOICE
	############################################################

	@api.model
	def getAccountInvoiceDental(self,domain):
		AccountInvoice = self.env['account.invoice'].search(domain)
		decimal_precision = self.env['decimal.precision'].precision_get('Account')
		values = []
		for invoice in AccountInvoice:
			values.append({
				'id': invoice.id,
				'type': invoice.type,
				'state': invoice.state,
				'number': invoice.number,
				'journal_id': [
					invoice.journal_id.id,
					invoice.journal_id.name
				],
				'invoice_currency': [
					invoice.currency_id.id,
					invoice.currency_id.name,
					invoice.currency_id.rate
				],
				'company_currency': [
					invoice.company_id.currency_id.id,
					invoice.company_id.currency_id.name,
					invoice.company_id.currency_id.rate
				],
				'date_invoice': invoice.date_invoice,
				'partner_id': [
					invoice.partner_id.id,
					invoice.partner_id.name,
					invoice.partner_id.ruc,
					invoice.partner_id.email,
					invoice.partner_id.mobile,
				],
				'supplier_invoice_number': invoice.supplier_invoice_number,
				'user_id': [
					invoice.user_id.id,
					invoice.user_id.name
				],
                'period_id': [
                	invoice.period_id.id,
                	invoice.period_id.name
                ],
				'date_due': invoice.date_due,
				'origin': invoice.origin,
				'name': invoice.name,
				'supplier_invoice_number': invoice.supplier_invoice_number,
				'reference': invoice.reference,
                'amount_untaxed': invoice.amount_untaxed,
                'residual': invoice.residual,
                'amount_tax': invoice.amount_tax,
				'amount_total': invoice.amount_total,
				'amount_untaxed_currency': invoice.amount_untaxed * (invoice.company_id.currency_id.rate / invoice.currency_id.rate),
				'residual_currency': invoice.residual * (invoice.company_id.currency_id.rate / invoice.currency_id.rate),
				'amount_tax_currency': invoice.amount_tax * (invoice.company_id.currency_id.rate / invoice.currency_id.rate),
				'amount_total_currency': invoice.amount_total * (invoice.company_id.currency_id.rate / invoice.currency_id.rate),
				'comment' : invoice.comment,
			})

		return values

class AccountInvoiceLine(models.Model):
	_inherit = 'account.invoice.line'

	############################################################
	#	ACCOUNT INVOICE LINE
	############################################################

	@api.model
	def getAccountInvoiceLineDental(self,domain):
		AccountInvoiceLine = self.env['account.invoice.line'].search(domain)
		decimal_precision = self.env['decimal.precision'].precision_get('Account')
		values = []
		for line in AccountInvoiceLine:
			values.append({
				'id': line.id,
				'name' : line.name,
				'invoice_id':line.invoice_id.id,
				'journal_id' : line.invoice_id.journal_id.id,
				'product_id': {
					'id' : line.product_id.id,
					'name' : line.product_id.name,
					'standard_price' : line.product_id.standard_price,
					'default_code' : line.product_id.default_code,
					'product_brand_id' : line.product_id.product_brand_id.name,
					'ean13' : line.product_id.ean13,
					'categ_id' : line.product_id.categ_id.name,
					'qty_available' : line.product_id.qty_available,
				},
				'quantity' : line.quantity,
				'price_unit' : line.price_unit,
			})

		return values

class AccountVoucher(models.Model):
	_inherit = 'account.voucher'

	############################################################
	#	ACCONT VOUCHER
	############################################################

	@api.model
	def getAccountVoucherDental(self,domain):
		AccountVoucher = self.env['account.voucher'].search(domain)
		values = []
		for voucher in AccountVoucher:
			values.append({
				'id': voucher.id,
				'number':voucher.number,
				'journal_id': voucher.journal_id.id,
				'amount': voucher.amount,
				'reference' : voucher.reference,
			})

		return values
